let diálogos = Juglar.NuevaActividad('diálogo');

(()=>{ // Inicio del módulo de diálogos
diálogos.Inicia = IniciaDiálogo

listaDiálogos = {}
diálogos.Añade=function(nombre, contenido){
	listaDiálogos[nombre] = contenido
}

let pantallaJuego = Juglar.ObtenerElementos('body')
let elementoDiálogo = Juglar.ObtenerElementos('diálogo-personajes')
let diálogoActual
let númeroDeLíneaActual
let saltandoDiálogo=false
function IniciaDiálogo(nombre){
	if(!listaDiálogos[nombre]) throw new Error(`No existe el diálogo "${nombre}"`)
	
	saltandoDiálogo=false

	pantallaJuego.AñadeClase('mostrarDiálogo')
	
	diálogoActual = listaDiálogos[nombre]
	númeroDeLíneaActual = -1
	diálogos.MuestraSiguienteLínea()
}

diálogos.pausaDiálogo = false
diálogos.MuestraSiguienteLínea = function(){
	númeroDeLíneaActual++
	if(diálogoActual.length <= númeroDeLíneaActual)
		return pantallaJuego.QuitaClase('mostrarDiálogo')
	
	const línea = diálogoActual[númeroDeLíneaActual]
	
	if(typeof línea === 'string') return MuestraTextoDiálogo(línea)
		
	if(línea.si && !CumpleCondición(línea.si)) return PasaLínea()
	
	for(const etiqueta in acciones)
		if(línea[etiqueta])
			acciones[etiqueta](línea[etiqueta], línea)
	
	if(!diálogos.pausaDiálogo) PasaLínea()
	
	diálogos.pausaDiálogo = false
}

let botónSaltar = Juglar.ObtenerElementos('diálogo-personajes botón-saltar')
botónSaltar.AlPulsar(SaltaDiálogo)

function SaltaDiálogo(){
	saltandoDiálogo=true
	diálogos.MuestraSiguienteLínea()
}

campoTextoDiálogo = Juglar.ObtenerElementos('diálogo-personajes texto-frase')
function MuestraTextoDiálogo(línea){
	campoTextoDiálogo.PonTexto(línea)
	if(saltandoDiálogo) setTimeout(()=>diálogos.MuestraSiguienteLínea(),50)
}

function CumpleCondición(condición){
	if (typeof condición === 'function') return condición()
	if(!condiciones[condición]) throw new Error(`No existe la condición "${condición}"`)
	return condiciones[condición]()
}

function PasaLínea(){
	setTimeout(()=>diálogos.MuestraSiguienteLínea(),1)
}

let botónContinuar = Juglar.ObtenerElementos('diálogo-personajes globo-frase button')
botónContinuar.AlPulsar(PulsaBotónContinuar)

function PulsaBotónContinuar(){
	botónContinuar.AñadeClase('desactivar')
	setTimeout(()=>botónContinuar.QuitaClase('desactivar'),200)
	PasaLínea()
}

acciones = {}
diálogos.AñadeAcción = function(etiqueta, acción){
	acciones[etiqueta] = acción
}

condiciones = {}
diálogos.AñadeCondición = function AñadeCondición(etiqueta, condición){
	condiciones[etiqueta] = condición
}

let campoNombrePersonaje = Juglar.ObtenerElementos('nombre-personaje')
diálogos.AñadeAcción("personaje",(nombre, línea)=>{
	campoNombrePersonaje.PonTexto(nombre)
	elementoDiálogo.PonAtributo('data-personaje',nombre)
})

let elementoFondo = Juglar.ObtenerElementos('body')
diálogos.AñadeAcción("fondo",(fondo, línea)=>{
	elementoFondo.primerNodo.setAttribute('data-fondo',fondo)
})

diálogos.AñadeAcción("aviso",(mensaje)=>{
	Juglar.EnvíaAviso(mensaje)
})

diálogos.AñadeAcción("música",(canción)=>{
	var audio = new Audio(canción);
	audio.play();
})

diálogos.AñadeAcción("guarda", (variable, línea)=>{
	if(Estado[variable] === undefined) Estado[variable] = 0
	if(línea.valor) Estado[variable] = línea.valor
	if(línea.suma) Estado[variable] += línea.suma
	if(línea.resta) Estado[variable] -= línea.resta
	console.log(Estado[variable])
})

let campoOpciones = Juglar.ObtenerElementos('diálogo-personajes opciones-diálogo')
diálogos.AñadeAcción("opciones", (opciones)=>{
	elementoDiálogo.AñadeClase('modoOpciones')
	diálogos.pausaDiálogo = true
	
	let listaOpciones=''
	for(const opción of opciones)
		listaOpciones+=`<button data-continúa="${opción.continúa?opción.continúa:''}">${opción.texto}</button>`
	campoOpciones.html = listaOpciones
	
	Juglar.ObtenerElementos('diálogo-personajes opciones-diálogo > button').AlPulsar(botón=>{
		elementoDiálogo.QuitaClase('modoOpciones')
		const continúa = botón.ObtenerAtributo("data-continúa")
		console.log(continúa)
		if(continúa) IniciaDiálogo(continúa)
		else diálogos.MuestraSiguienteLínea()
	})
})

diálogos.AñadeAcción("continúa", (diálogo)=>{
	IniciaDiálogo(diálogo)
	diálogos.pausaDiálogo = true
})

})() // Fin del módulo de diálogos