let Estado ={
	
}

let Juglar = {
	actividades:{},
	
	MuestraPágina(página){
		Juglar.ObtenerElementos('.actual').QuitaClase('actual')
		Juglar.ObtenerElementos('.'+página).AñadeClase('actual')
	},
	
	NuevaActividad(nombre){
		const actividad ={'nombre':nombre}
		
		this.ObtenerElementos('body > .'+nombre+' [data-pulsa]').AlPulsar((botón)=>{
			const nombreAcción = botón.ObtenerAtributo('data-pulsa')
			if(!actividad.acciones[nombreAcción]) new Error(`No existe la acción "${nombreAcción}" en la actividad "${nombre}"`)
			
			actividad.acciones[nombreAcción]()
		})
		
		actividad.campos={}
		for(const nodo of this.ObtenerElementos('body > .'+nombre+' [data-campo]').nodos){
			let campo = ClonarObjeto(SelectorJuglar)
			campo.nodos = [nodo]
			const nombreCampo = campo.ObtenerAtributo('data-campo')
			if(actividad.campos[nombreCampo]) new Error(`Ta existe el campo "${nombreCampo}" en la actividad "${nombre}"`)
			
			actividad.campos[nombreCampo] = campo
		}
		
		this.actividades[nombre]=actividad
		return actividad
	},
	
	GuardaPartida(){
		
		let datosPartida={'estado':Estado,actividades:{}}
		
		for(const nombre in this.actividades)
			if(this.actividades[nombre].GuardaDatos)
				datosPartida.actividades[nombre] = this.actividades[nombre].GuardaDatos()
			
		localStorage.setItem('partida',JSON.stringify(datosPartida))
	},
	
	ExistePartida(){
		return null!==localStorage.getItem('partida')
	},
	
	CargaPartida(){
		const datosPartida = JSON.parse(localStorage.getItem('partida'))
		Estado=datosPartida.estado
		
		for(const nombre in this.actividades)
			if(this.actividades[nombre].CargaDatos)
				this.actividades[nombre].CargaDatos(datosPartida.actividades[nombre])
	},
	
	EsperaSegundos(segundos, función){
		setTimeout(función,segundos*1000)
	},
}



Juglar.ObtenerElementos = function(selector){
	let NuevoSelector = ClonarObjeto(SelectorJuglar)
	NuevoSelector.nodos = document.querySelectorAll(selector)
	return NuevoSelector;
}

Juglar.accionesAvisadas=[]
Juglar.AlRecibirAvisos = function(acción){
	this.accionesAvisadas.push(acción)
}

Juglar.accionesAvisadasConcretas = {}
Juglar.AlRecibirAviso = function(mensaje, acción){
	if(!this.accionesAvisadasConcretas[mensaje]) this.accionesAvisadasConcretas[mensaje]=[]
	this.accionesAvisadasConcretas[mensaje].push(acción)
}

Juglar.EnvíaAviso = function(mensaje){
	for(accion of this.accionesAvisadas)
		accion(mensaje)
	
	if(this.accionesAvisadasConcretas[mensaje])
		for(accion of this.accionesAvisadasConcretas[mensaje])
			accion(mensaje)
}



SelectorJuglar={}

SelectorJuglar.PonTexto = function(texto){
	this.nodos.forEach(nodo=>nodo.textContent = texto)
}

SelectorJuglar.ObtenerTexto = function(texto){
	if(this.nodos.length <= 0) return undefined
	return this.nodos[0].textContent
}

Object.defineProperty(SelectorJuglar, 'texto', {
	get() {
		if(this.nodos.length <= 0) return undefined
		return this.nodos[0].textContent
	},

	set(texto) {
		this.nodos.forEach(nodo=>nodo.textContent = texto)
	}
});


Object.defineProperty(SelectorJuglar, 'número', {
	get() {
		if(this.nodos.length <= 0) return undefined
		return parseFloat(this.nodos[0].textContent)
	},

	set(número) {
		this.nodos.forEach(nodo=>nodo.textContent = número)
	}
});

Object.defineProperty(SelectorJuglar, 'html', {
	get() {
		if(this.nodos.length <= 0) return undefined
		return this.nodos[0].innerHTML
	},

	set(texto) {
		this.nodos.forEach(nodo=>nodo.innerHTML = texto)
	}
});

Object.defineProperty(SelectorJuglar, 'primerNodo', {
	get() {
		if(this.nodos.length<1) return null
		return this.nodos[0]
	},
});

Object.defineProperty(SelectorJuglar, 'padre', {
	get() {
		let NuevoSelector = ClonarObjeto(SelectorJuglar)
		NuevoSelector.nodos = [this.nodos[0].parentNode]
		return NuevoSelector
	},
});

SelectorJuglar.PonHTML = function(html){
	this.nodos.forEach(nodo=>nodo.innerHTML = html)
}

SelectorJuglar.AñadeHTML = function(html){
	this.nodos.forEach(nodo=>nodo.insertAdjacentHTML("beforeend",html))
}

SelectorJuglar.PonEstilo = function(propiedad, valor){
	this.nodos.forEach(nodo=>nodo.style[propiedad] = valor)
}

SelectorJuglar.AlPulsar = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("click", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.AlTocar = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("pointerdown", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.AlMover = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("pointermove", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.AlSoltar = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("pointerup", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}


SelectorJuglar.AlMoverDentro = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("pointerenter", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.AlMoverFuera = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("pointerleave", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.AlTerminarAnimación = function(función){
	this.nodos.forEach(nodo=>{
		nodo.addEventListener("animationend", evento=>{
			let NuevoSelector = ClonarObjeto(SelectorJuglar)
			NuevoSelector.nodos = [evento.currentTarget]
			función(NuevoSelector,evento)
		})
	})
}

SelectorJuglar.QuitaClase = function(clase){
	this.nodos.forEach(nodo=>nodo.classList.remove(clase))
}

SelectorJuglar.AñadeClase = function(clase){
	this.nodos.forEach(nodo=>nodo.classList.add(clase))
}

SelectorJuglar.TieneClase = function(clase){
	let tiene = false
	this.nodos.forEach(nodo=>tiene=tiene || nodo.classList.contains(clase))
	return tiene
}

SelectorJuglar.ObtenerAtributo = function(atributo){
	return this.nodos[0].getAttribute(atributo)
}

SelectorJuglar.PonAtributo = function(atributo, valor){
	return this.nodos[0].setAttribute(atributo, valor)
}

SelectorJuglar.PonEstilo = function(atributo, valor){
	this.nodos[0].style[atributo] = valor
}

function Desordenar(array) {
  let currentIndex = array.length,  randomIndex;
  while (currentIndex != 0) {
    randomIndex = Math.floor(Math.random() * currentIndex);
    currentIndex--;

    [array[currentIndex], array[randomIndex]] = [array[randomIndex], array[currentIndex]];
  }
  return array;
}

function ClonarObjeto(obj) {
    var clone = Object.create(Object.getPrototypeOf(obj));

    var props = Object.getOwnPropertyNames(obj);
    props.forEach(function(key) {
        var desc = Object.getOwnPropertyDescriptor(obj, key);
        Object.defineProperty(clone, key, desc);
    });

    return clone;
}

function EscogeAlAzar(array) {
  return array[Math.floor(Math.random()*array.length)];
}